﻿// ****************************************************** 
// 文件名称(File Name)：       Customers.cs
// 项目名称(Project Name)：    WebForm_JQuery_MiniUI_EF4联创专用版
// 功能描述(Description)：     客户 （数据模型）
// 数据表(Tables)：            Customers（所用到的数据表，视图，存储过程的说明，如关系比较复杂，则应说明哪些是可擦写的，哪些表为只读的）
// 作者(Author)：              zhaoshunlu@163.com
// 日期(Create Date)：         2014-10-01 08:50:42
// 参考文档(Reference)(可选)： （该档所对应的分析文档，设计文檔）
// 引用(Using) (可选)﹕        （开发的系统中引用其它系统的Dll、对象时，要列出其对应的出处，是否与系统有关﹙不清楚的可以不写﹚，以方便制作安装档）
// 编码约定：                   命名规则(类名和属性名首字母必须大写)
// 修改记录(Revision History)：（若档案的所有者改变，则需要有修改人员的名字、修改日期及修改理由）
//****************************************************** 
using System;
using System.Collections.Generic;
using Newtonsoft.Json; //[JsonIgnore]//使用JsonConvert序列化时不序列化此字段

namespace Mammonth.Model {

    //保持与架构无关性的POCO类

    //命名规则：类名和属性名首字母必须大写    

    /// <summary>
    /// 客户（Customers）
    /// </summary>               
    /// <remarks> 
    /// 创建人及日期：zhaoshunlu@163.com 2014-10-01 08:50:42
    /// <para>修改人、日期及内容:</para>
    /// </remarks>
    public class Customers : Mammonth.Model._common {
        /// <summary>
        /// 客户
        /// </summary>
        public Customers() {
            //不允许null的属性及设置有默认值的属性
			this.CustomerID = "" ;			// 客户ID Not NULL 
			this.CompanyName = "" ;			// 公司名称 Not NULL 

			CustomerCustomerDemos = new List<CustomerCustomerDemo>();  
			Orderss = new List<Orders>();  

        }

		/// <summary>
		/// 客户ID (Not NULL)
		/// </summary>
		/// <value>string</value>
        public string CustomerID {get;set;}
		/// <summary>
		/// 公司名称 (Not NULL)
		/// </summary>
		/// <value>string</value>
        public string CompanyName {get;set;}
		/// <summary>
		/// 联系人姓名 
		/// </summary>
		/// <value>string</value>
        public string ContactName {get;set;}
		/// <summary>
		/// 联系人职位 
		/// </summary>
		/// <value>string</value>
        public string ContactTitle {get;set;}
		/// <summary>
		/// 地址 
		/// </summary>
		/// <value>string</value>
        public string Address {get;set;}
		/// <summary>
		/// 城市 
		/// </summary>
		/// <value>string</value>
        public string City {get;set;}
		/// <summary>
		/// 地区 
		/// </summary>
		/// <value>string</value>
        public string Region {get;set;}
		/// <summary>
		/// 邮政编码 
		/// </summary>
		/// <value>string</value>
        public string PostalCode {get;set;}
		/// <summary>
		/// 国家 
		/// </summary>
		/// <value>string</value>
        public string Country {get;set;}
		/// <summary>
		/// 电话 
		/// </summary>
		/// <value>string</value>
        public string Phone {get;set;}
		/// <summary>
		/// 传真 
		/// </summary>
		/// <value>string</value>
        public string Fax {get;set;}


	    /// <summary> 
	    /// 客户测试(子表) 
	    /// </summary> 
	    public virtual IList<CustomerCustomerDemo> CustomerCustomerDemos {get;set;} 
	    /// <summary> 
	    /// 订单(子表) 
	    /// </summary> 
	    public virtual IList<Orders> Orderss {get;set;} 


        
    }
}