﻿// ****************************************************** 
// 文件名称(File Name)：       Region.cs
// 项目名称(Project Name)：    YourProjectName
// 功能描述(Description)：     地区 （数据模型）
// 数据表(Tables)：            Region（所用到的数据表，视图，存储过程的说明，如关系比较复杂，则应说明哪些是可擦写的，哪些表为只读的）
// 作者(Author)：              zhaoshunlu@163.com
// 日期(Create Date)：         2014-10-21 22:17:27
// 参考文档(Reference)(可选)： （该档所对应的分析文档，设计文檔）
// 引用(Using) (可选)﹕        （开发的系统中引用其它系统的Dll、对象时，要列出其对应的出处，是否与系统有关﹙不清楚的可以不写﹚，以方便制作安装档）
// 编码约定：                   命名规则(类名和属性名首字母必须大写)
// 修改记录(Revision History)：（若档案的所有者改变，则需要有修改人员的名字、修改日期及修改理由）
//****************************************************** 
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Newtonsoft.Json; //[JsonIgnore]//使用JsonConvert序列化时不序列化此字段

namespace Northwind.Model {

    //保持与架构无关性的POCO类

    //命名规则：类名和属性名首字母必须大写    

    /// <summary>
    /// 地区（Region）
    /// </summary>               
    /// <remarks> 
    /// 创建人及日期：zhaoshunlu@163.com 2014-10-21 22:17:27
    /// <para>修改人、日期及内容:</para>
    /// </remarks>
    public class Region : Northwind.Model._common {
        /// <summary>
        /// 地区
        /// </summary>
        public Region() {
            //不允许null的属性及设置有默认值的属性
			this.RegionID = 0 ;			// 地区ID Not NULL 
			this.RegionDescription = "" ;			// 地区描述 Not NULL 

			//Territoriess = new List<Territories>();  

        }

		/// <summary>
		/// 地区ID (Not NULL)
		/// </summary>
		/// <value>int</value>
	    [Display(Name = "地区ID")]
        public int RegionID {get;set;}
		/// <summary>
		/// 地区描述 (Not NULL)
		/// </summary>
		/// <value>string</value>
	    [Display(Name = "地区描述")]
        public string RegionDescription {get;set;}


	    ///// <summary> 
	    ///// 领域(子表) 
	    ///// </summary> 
	    //public virtual IList<Territories> Territoriess {get;set;} 


        
    }
}