﻿Go
if exists (select * from sysobjects where id = OBJECT_ID('[Employees]') and OBJECTPROPERTY(id, 'IsUserTable') = 1) 
	DROP TABLE [Employees]
Go

CREATE TABLE [Employees] (
EmployeeID       int IDENTITY (1, 1) NOT NULL,   -- 雇员ID
LastName         nvarchar(20) NOT NULL,          -- 姓氏
FirstName        nvarchar(10) NOT NULL,          -- 名称
Title            nvarchar(30) NULL,              -- 职位
TitleOfCourtesy  nvarchar(25) NULL,              -- 尊称
BirthDate        datetime NULL,                  -- 出生日期
HireDate         datetime NULL,                  -- 雇用日期
Address          nvarchar(60) NULL,              -- 地址
City             nvarchar(15) NULL,              -- 城市
Region           nvarchar(15) NULL,              -- 地区
PostalCode       nvarchar(10) NULL,              -- 邮政编码
Country          nvarchar(15) NULL,              -- 国家
HomePhone        nvarchar(24) NULL,              -- 家庭电话
Extension        nvarchar(4) NULL,               -- 电话分机
Photo            image NULL,                     -- 照片
Notes            ntext NULL,                     -- 备注
ReportsTo        int NULL,                       -- 上级雇员
PhotoPath        nvarchar(255) NULL              -- 图片路径

CONSTRAINT [PK_Employees] PRIMARY KEY CLUSTERED ([EmployeeID])
)
--添加表注释
exec sp_addextendedproperty N'MS_Description', N'雇员', N'user', N'dbo', N'table', N'Employees'

--添加列注释
exec sp_addextendedproperty N'MS_Description', N'雇员ID', N'user', N'dbo', N'table', N'Employees', N'column', N'EmployeeID'
exec sp_addextendedproperty N'MS_Description', N'姓氏', N'user', N'dbo', N'table', N'Employees', N'column', N'LastName'
exec sp_addextendedproperty N'MS_Description', N'名称', N'user', N'dbo', N'table', N'Employees', N'column', N'FirstName'
exec sp_addextendedproperty N'MS_Description', N'职位', N'user', N'dbo', N'table', N'Employees', N'column', N'Title'
exec sp_addextendedproperty N'MS_Description', N'尊称', N'user', N'dbo', N'table', N'Employees', N'column', N'TitleOfCourtesy'
exec sp_addextendedproperty N'MS_Description', N'出生日期', N'user', N'dbo', N'table', N'Employees', N'column', N'BirthDate'
exec sp_addextendedproperty N'MS_Description', N'雇用日期', N'user', N'dbo', N'table', N'Employees', N'column', N'HireDate'
exec sp_addextendedproperty N'MS_Description', N'地址', N'user', N'dbo', N'table', N'Employees', N'column', N'Address'
exec sp_addextendedproperty N'MS_Description', N'城市', N'user', N'dbo', N'table', N'Employees', N'column', N'City'
exec sp_addextendedproperty N'MS_Description', N'地区', N'user', N'dbo', N'table', N'Employees', N'column', N'Region'
exec sp_addextendedproperty N'MS_Description', N'邮政编码', N'user', N'dbo', N'table', N'Employees', N'column', N'PostalCode'
exec sp_addextendedproperty N'MS_Description', N'国家', N'user', N'dbo', N'table', N'Employees', N'column', N'Country'
exec sp_addextendedproperty N'MS_Description', N'家庭电话', N'user', N'dbo', N'table', N'Employees', N'column', N'HomePhone'
exec sp_addextendedproperty N'MS_Description', N'电话分机', N'user', N'dbo', N'table', N'Employees', N'column', N'Extension'
exec sp_addextendedproperty N'MS_Description', N'照片', N'user', N'dbo', N'table', N'Employees', N'column', N'Photo'
exec sp_addextendedproperty N'MS_Description', N'备注', N'user', N'dbo', N'table', N'Employees', N'column', N'Notes'
exec sp_addextendedproperty N'MS_Description', N'上级雇员', N'user', N'dbo', N'table', N'Employees', N'column', N'ReportsTo'
exec sp_addextendedproperty N'MS_Description', N'图片路径', N'user', N'dbo', N'table', N'Employees', N'column', N'PhotoPath'
