﻿Go
if exists (select * from sysobjects where id = OBJECT_ID('[Suppliers]') and OBJECTPROPERTY(id, 'IsUserTable') = 1) 
	DROP TABLE [Suppliers]
Go

CREATE TABLE [Suppliers] (
SupplierID    int IDENTITY (1, 1) NOT NULL,   -- 供应商ID
CompanyName   nvarchar(40) NOT NULL,          -- 公司名称
ContactName   nvarchar(30) NULL,              -- 联系人名称
ContactTitle  nvarchar(30) NULL,              -- 联系人职务
Address       nvarchar(60) NULL,              -- 地址
City          nvarchar(15) NULL,              -- 城市
Region        nvarchar(15) NULL,              -- 地区
PostalCode    nvarchar(10) NULL,              -- 邮政编码
Country       nvarchar(15) NULL,              -- 国家
Phone         nvarchar(24) NULL,              -- 电话
Fax           nvarchar(24) NULL,              -- 传真
HomePage      ntext NULL                      -- 主页

CONSTRAINT [PK_Suppliers] PRIMARY KEY CLUSTERED ([SupplierID])
)
--添加表注释
exec sp_addextendedproperty N'MS_Description', N'供应商', N'user', N'dbo', N'table', N'Suppliers'

--添加列注释
exec sp_addextendedproperty N'MS_Description', N'供应商ID', N'user', N'dbo', N'table', N'Suppliers', N'column', N'SupplierID'
exec sp_addextendedproperty N'MS_Description', N'公司名称', N'user', N'dbo', N'table', N'Suppliers', N'column', N'CompanyName'
exec sp_addextendedproperty N'MS_Description', N'联系人名称', N'user', N'dbo', N'table', N'Suppliers', N'column', N'ContactName'
exec sp_addextendedproperty N'MS_Description', N'联系人职务', N'user', N'dbo', N'table', N'Suppliers', N'column', N'ContactTitle'
exec sp_addextendedproperty N'MS_Description', N'地址', N'user', N'dbo', N'table', N'Suppliers', N'column', N'Address'
exec sp_addextendedproperty N'MS_Description', N'城市', N'user', N'dbo', N'table', N'Suppliers', N'column', N'City'
exec sp_addextendedproperty N'MS_Description', N'地区', N'user', N'dbo', N'table', N'Suppliers', N'column', N'Region'
exec sp_addextendedproperty N'MS_Description', N'邮政编码', N'user', N'dbo', N'table', N'Suppliers', N'column', N'PostalCode'
exec sp_addextendedproperty N'MS_Description', N'国家', N'user', N'dbo', N'table', N'Suppliers', N'column', N'Country'
exec sp_addextendedproperty N'MS_Description', N'电话', N'user', N'dbo', N'table', N'Suppliers', N'column', N'Phone'
exec sp_addextendedproperty N'MS_Description', N'传真', N'user', N'dbo', N'table', N'Suppliers', N'column', N'Fax'
exec sp_addextendedproperty N'MS_Description', N'主页', N'user', N'dbo', N'table', N'Suppliers', N'column', N'HomePage'
